package cz.muni.fi.pb162.firetrucks;


import java.lang.reflect.Method;
import junit.framework.TestCase;



/**
 * The test class TankTruckImplTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class LadderTruckImplTest extends TestCase
{
    /**
     * Default constructor for test class TankTruckImplTest
     */
    public LadderTruckImplTest(String testName)
    {
        super(testName);
    }
    
    public void testMethodsAndAttributes() {
        BasicRulesTester.testMethodsAndAttributes(LadderTruckImpl.class);
    }
    
    public void testNew() {
        LadderTruckImpl tt = new LadderTruckImpl(3, 80);
    
        assertEquals("Metoda LadderTruckImpl.getLadderLength() nevraci spravnou hodnotu",
        80,tt.getLadderLength());
        assertEquals("Metoda LadderTruckImpl.getCrew() nevraci spravnou hodnotu",
        3,tt.getCrew());        
    }
    
    
    public void testToString() {
        LadderTruck tt = new LadderTruckImpl(3, 80);
        BasicRulesTester.assertToString(tt,"Ladder fire truck with ladder" +
        " length: 80m");
    }
    
    public void testGetCrew() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getCrew",
        LadderTruckImpl.class, AbstractFireTruck.class);
    }
    
    public void testRequiredForFireAccidents() {
        assertFalse("Metoda LadderTruckImpl.requiredForFireAccidents() nevraci spravnou hodnotu",
        new LadderTruckImpl(0,0).requiredForFireAccidents());
    }

    public void testRequiredForTrafficAccidents() {
        assertFalse("Metoda LadderTruckImpl.requiredForTrafficAccidents() nevraci spravnou hodnotu",
        new LadderTruckImpl(0,0).requiredForTrafficAccidents());
    }
}