package cz.muni.fi.pb162.firetrucks;

import java.lang.reflect.Method;
import junit.framework.TestCase;



/**
 * The test class TankTruckImplTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class TankTruckImplTest extends TestCase
{
    /**
     * Default constructor for test class TankTruckImplTest
     */
    public TankTruckImplTest(String testName)
    {
        super(testName);
    }
    
    public void testMethodsAndAttributes() {
        BasicRulesTester.testMethodsAndAttributes(TankTruckImpl.class);
    }
    
    public void testNew() {
        TankTruckImpl tt = new TankTruckImpl(3, 8000, 2400);
    
        assertEquals("Metoda TankTruckImpl.getTankCapacity() nevraci spravnou hodnotu",
        8000,tt.getTankCapacity());
        assertEquals("Metoda TankTruckImpl.getCrew() nevraci spravnou hodnotu",
        3,tt.getCrew());
        assertEquals("Metoda TankTruckImpl.getPumpOutput() nevraci spravnou hodnotu",
        2400,tt.getPumpOutput());
        assertEquals("Metoda TankTruckImpl.getMinJettingPeriod() nevraci spravnou hodnotu",
        3,tt.getMinJettingPeriod());
    }
    
    
    public void testToString() {
        TankTruck tt = new TankTruckImpl(3, 8000, 2400);
        BasicRulesTester.assertToString(tt,"Tank fire truck with 8000l" +
        " of water and 2400l/min pump");
    }
    
    public void testGetCrew() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getCrew",
        TankTruckImpl.class, AbstractFireTruck.class);
    }
    
    public void testRequiredForFireAccidents() {
        assertTrue("Metoda TankTruckImpl.requiredForFireAccidents() nevraci spravnou hodnotu",
        new TankTruckImpl(0,0,0).requiredForFireAccidents());
    }

    public void testRequiredForTrafficAccidents() {
        assertFalse("Metoda TankTruckImpl.requiredForTrafficAccidents() nevraci spravnou hodnotu",
        new TankTruckImpl(0,0,0).requiredForTrafficAccidents());
    }
}
