package cz.muni.fi.pb162.firetrucks;


import java.lang.reflect.Method;
import junit.framework.TestCase;



/**
 * The test class TankTruckImplTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class CrashTruckImplTest extends TestCase
{
    /**
     * Default constructor for test class TankTruckImplTest
     */
    public CrashTruckImplTest(String testName)
    {
        super(testName);
    }
    
    public void testMethodsAndAttributes() {
        BasicRulesTester.testMethodsAndAttributes(CrashTruckImpl.class);
    }
    
    public void testNew() {
        CrashTruckImpl tt = new CrashTruckImpl(3, 8000, 2400,
        new RescueEquipment("aaa", "bbb", 2000));
    
        assertEquals("Metoda CrashTruckImpl.getWreckingDeviceName() nevraci spravnou hodnotu",
        "aaa",tt.getWreckingDeviceName());
        assertEquals("Metoda CrashTruckImpl.getGeneratorName() nevraci spravnou hodnotu",
        "bbb",tt.getGeneratorName());
        assertEquals("Metoda TankTruckImpl.getTankCapacity() nevraci spravnou hodnotu",
        8000,tt.getTankCapacity());
        assertEquals("Metoda TankTruckImpl.getCrew() nevraci spravnou hodnotu",
        3,tt.getCrew());
        assertEquals("Metoda TankTruckImpl.getPumpOutput() nevraci spravnou hodnotu",
        2400,tt.getPumpOutput());
        assertEquals("Metoda TankTruckImpl.getMinJettingPeriod() nevraci spravnou hodnotu",
        3,tt.getMinJettingPeriod());
     }
    
    
    public void testToString() {
        CrashTruck tt = new CrashTruckImpl(3, 8000, 2400, 
        new RescueEquipment("aaa", "bbb", 2000));
        
        BasicRulesTester.assertToString(tt,"Crash fire truck with rescue" +
        " equipment: aaa, bbb");
    }
    
    public void testGetCrew() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getCrew",
        CrashTruckImpl.class, AbstractFireTruck.class);
    }
    
    public void testGetTankCapacity() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getTankCapacity",
        CrashTruckImpl.class, TankTruckImpl.class);
    }
    
    public void testGetPumpOutput() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getPumpOutput",
        CrashTruckImpl.class, TankTruckImpl.class);
    }

    public void testMinJettingPeriod() {
        BasicRulesTester.assertMethodDeclaredInAncestor("getMinJettingPeriod",
        CrashTruckImpl.class, TankTruckImpl.class);
    }

    public void testRequiredForFireAccidents() {
        assertFalse("Metoda CrashTruckImpl.requiredForFireAccidents() nevraci spravnou hodnotu",
        new CrashTruckImpl(0,0,0, new RescueEquipment("a","b",0)).requiredForFireAccidents());
    }

    public void testRequiredForTrafficAccidents() {
        assertTrue("Metoda CrashTruckImpl.requiredForTrafficAccidents() nevraci spravnou hodnotu",
        new CrashTruckImpl(0,0,0, new RescueEquipment("a","b",0)).requiredForTrafficAccidents());
    }    
}