package cz.muni.fi.pb162.firetrucks;

/**
 * This interface represents a ladder fire truck.
 * 
 * These trucks are sent to traffic accidents only if necessary (occasionally).
 * These trucks are sent to fire accidents only if necessary (occasionally).
 *
 * @author Radek Oslejsek
 * @version 2007-10-12
 */
public interface LadderTruck extends FireTruck 
{
    /**
     * Returns maximal length of the ledder.
     * 
     * @return maximal length of the ledder
     */
    int getLadderLength();
}
