package cz.muni.fi.pb162.firetrucks;


/**
 * This interface represents a rescue equipment.
 *
 * @author Radek Oslejsek
 * @version 2007-10-12
 */
public class RescueEquipment
{
    private String wreckingDevice;
    private String generator;
    private int    totalWeight;
    
    public RescueEquipment(String wd, String eg, int w) {
        wreckingDevice = wd;
        generator = eg;
        totalWeight = w;
    }
    
    /**
     * @return total weight of equipment in tonnes
     */
    public int getWeight() {
        return totalWeight;
    }
    
    public String getWreckingDeviceName() {
        return wreckingDevice;
    }
    
    public String getGeneratorName() {
        return generator;
    }
    
    public String toString() {
        return getWreckingDeviceName() + ", " + getGeneratorName();
    }
}
